//
//  IFC97_Tsat_hs.h
//  IFC97
//
//  Created by Rodrigo Carvajal on 12/Dec/12.
//  Copyright (c) 2012 Rodrigo Carvajal. All rights reserved.
//

#ifndef __IFC97__IFC97_Tsat_hs__
#define __IFC97__IFC97_Tsat_hs__

/*
Equations given below are based on the information provided in the IAPWS, Supplemetary Release on Backward Equations P(h,s) for Region 3, Equations as a Function of h and s for the Redion Boundaries, and an Equation Tsat(h,s) for Region 4 of the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam. Kyoto, Japan, September 2004
*/

// Region 4 Saturation temperature based on h,s for s>s''(623.15K)
double IFC97_Tsat_hs(double h, double s);  // Equation (9) of above reference

#endif /* defined(__IFC97__IFC97_Tsat_hs__) */
